;;;; synch-support.scm
;;;; Kon Lovett, Mar '06

(require-extension srfi-18)

(eval-when (compile)
  (declare
    (usual-integrations)
    (disable-interrupts)
    (inline)
    (fixnum)
    (no-procedure-checks)
    (no-bound-checks)
    (export
      make-object/synch
      object?/synch
      ; DEPRECATED
      make-synchronized-object
      synchronized-object?) ) )

;;;

(define (make-object/synch obj . args)
  (let-optionals args ([name '(synchobj)])
    (let ([mutex (make-mutex (if (pair? name) (gensym (car name)) name))])
      (mutex-specific-set! mutex obj)
      mutex ) ) )

(define object?/synch
  (let ([tpred (constantly #t)])
    (lambda (obj . pred)
      (and (mutex? obj)
           (let ([ms (mutex-specific obj)])
             (and (not (eq? (void) ms))
                  ((optional pred tpred) ms)) ) ) ) ) )

; DEPRECATED

(define make-synchronized-object make-object/synch)
(define synchronized-object? object?/synch)
